﻿using EPubLib;
using Microsoft.VisualStudio.TestTools.UnitTesting;
namespace Test
{
    
    
    /// <summary>
    ///This is a test class for BookTest and is intended
    ///to contain all BookTest Unit Tests
    ///</summary>
    [TestClass()]
    public class BookTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Save
        ///</summary>
        //[Ignore]
        [TestMethod()]
        public void SaveTest()
        {
            Book book = new Book(); // TODO: Initialize to an appropriate value
            string filename = string.Empty; // TODO: Initialize to an appropriate value
            book.Title = "The Economist";
            book.Identifier = "economist.com.20100122";

            Chapter chapter1 = new Chapter()
            {
                Title = "Chapter 1",
                Number = 1,
                Content = @"<?xml version=""1.0"" encoding=""UTF-8""?>
<!DOCTYPE html PUBLIC ""-//W3C//DTD XHTML 1.1//EN"" ""http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"">
<html><head><title>Chapter 1</title></head>
<body><h1>Chapter 1</h1><h2>A New Hope</h2><p>Well look here, it's content in an epub!</p></body></html>"
            };
            book.FileItems.Add(chapter1);

            Chapter chapter2 = new Chapter()
            {
                Title = "Chapter 2!",
                Number = 2,
                Content = @"<?xml version=""1.0"" encoding=""iso-8859-1""?>
<!DOCTYPE html PUBLIC ""-//W3C//DTD XHTML 1.1//EN"" ""http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"">
<html><head><title>Chapter 1</title></head>
<body><h1>Chapter 2</h1><h2>A New Hope</h2><p>Well look here, it's content in an epub!</p></body></html>"
            };
            book.FileItems.Add(chapter2);

            book.Save(@"C:\Projects\EPubLib\output.epub");

            //http://threepress.org/document/epub-validate/
            Assert.Inconclusive();
        }

        /// <summary>
        ///A test for GetContentOpf
        ///</summary>
        [TestMethod()]
        [DeploymentItem("EPubLib.dll")]
        public void GetContentOpfTest()
        {
            Book_Accessor book = new Book_Accessor(); // TODO: Initialize to an appropriate value
            book.Title = "The Economist";
            book.Identifier = "economist.com.20100122";

            Chapter chapter = new Chapter()
            {
                Title = "Chapter 1!",
                Number = 1
            };

            book.FileItems.Add(chapter);

            string expected = @"<?xml version=""1.0"" encoding=""utf-8""?>
<package version=""2.0"" xmlns=""http://www.idpf.org/2007/opf"" unique-identifier=""BookId"">
  <metadata xmlns:dc=""http://purl.org/dc/elements/1.1/"" xmlns:opf=""http://www.idpf.org/2007/opf"">
    <dc:title>The Economist</dc:title>
    <dc:creator opf:role=""aut"">epublib.codeplex.com</dc:creator>
    <dc:language>en-US</dc:language>
    <dc:rights>Public Domain</dc:rights>
    <dc:publisher>Economist.com</dc:publisher>
    <dc:identifier id=""BookId"">urn:uuid:economist.com.20100122</dc:identifier>
  </metadata>
  <manifest>
    <item id=""ncx"" href=""toc.ncx"" media-type=""application/x-dtbncx+xml"" />
    <item id=""chapter001"" href=""chapter001.xhtml"" media-type=""application/xhtml+xml"" />
  </manifest>
  <spine toc=""ncx"">
    <itemref idref=""chapter001"" />
  </spine>
</package>";

            string actual = book.GetContentOpf();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for GetToc
        ///</summary>
        [TestMethod()]
        [DeploymentItem("EPubLib.dll")]
        public void GetTocTest()
        {
            Book_Accessor book = new Book_Accessor(); // TODO: Initialize to an appropriate value

            book.Title = "The Economist";
            book.Identifier = "economist.com.20100122";

            Chapter chapter = new Chapter()
            {
                Title = "Chapter 1!",
                Number = 1
            };

            book.FileItems.Add(chapter);

            string expected = @"<?xml version=""1.0"" encoding=""utf-8""?>
<ncx xmlns=""http://www.daisy.org/z3986/2005/ncx/"" version=""2005-1"">
  <head>
    <meta name=""dtb:uid"" content=""economist.com.20100122"" />
    <meta name=""dtb:depth"" content=""1"" />
    <meta name=""dtb:totalPageCount"" content=""0"" />
    <meta name=""dtb:maxPageNumber"" content=""0"" />
  </head>
  <docTitle>
    <text>The Economist</text>
  </docTitle>
  <navMap>
    <navPoint id=""chapter001"" playOrder=""1"">
      <navLabel>
        <text>Chapter 1!</text>
      </navLabel>
      <content src=""chapter001.xhtml"" />
    </navPoint>
  </navMap>
</ncx>";
            string actual;
            actual = book.GetToc();
            Assert.AreEqual(expected, actual);
        }
    }
}
